-
Notifications
You must be signed in to change notification settings - Fork 43
/
MostStonesRemovedWithSameRowOrColumn.java
236 lines (199 loc) · 7.57 KB
/
MostStonesRemovedWithSameRowOrColumn.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
package LeetCodeJava.Array;
// https://leetcode.com/problems/most-stones-removed-with-same-row-or-column/description/
import java.util.*;
/**
* 947. Most Stones Removed with Same Row or Column
* Medium
* Topics
* Companies
* On a 2D plane, we place n stones at some integer coordinate points. Each coordinate point may have at most one stone.
*
* A stone can be removed if it shares either the same row or the same column as another stone that has not been removed.
*
* Given an array stones of length n where stones[i] = [xi, yi] represents the location of the ith stone, return the largest possible number of stones that can be removed.
*
*
*
* Example 1:
*
* Input: stones = [[0,0],[0,1],[1,0],[1,2],[2,1],[2,2]]
* Output: 5
* Explanation: One way to remove 5 stones is as follows:
* 1. Remove stone [2,2] because it shares the same row as [2,1].
* 2. Remove stone [2,1] because it shares the same column as [0,1].
* 3. Remove stone [1,2] because it shares the same row as [1,0].
* 4. Remove stone [1,0] because it shares the same column as [0,0].
* 5. Remove stone [0,1] because it shares the same row as [0,0].
* Stone [0,0] cannot be removed since it does not share a row/column with another stone still on the plane.
* Example 2:
*
* Input: stones = [[0,0],[0,2],[1,1],[2,0],[2,2]]
* Output: 3
* Explanation: One way to make 3 moves is as follows:
* 1. Remove stone [2,2] because it shares the same row as [2,0].
* 2. Remove stone [2,0] because it shares the same column as [0,0].
* 3. Remove stone [0,2] because it shares the same row as [0,0].
* Stones [0,0] and [1,1] cannot be removed since they do not share a row/column with another stone still on the plane.
* Example 3:
*
* Input: stones = [[0,0]]
* Output: 0
* Explanation: [0,0] is the only stone on the plane, so you cannot remove it.
*
*
* Constraints:
*
* 1 <= stones.length <= 1000
* 0 <= xi, yi <= 104
* No two stones are at the same coordinate point.
*
*
*
*/
public class MostStonesRemovedWithSameRowOrColumn {
// V0
// TODO : implement it
// public int removeStones(int[][] stones) {
//
// }
// V1-1
// IDEA : DFS
// https://leetcode.com/problems/most-stones-removed-with-same-row-or-column/editorial/
public int removeStones_1_1(int[][] stones) {
int n = stones.length;
// Adjacency list to store graph connections
List<Integer>[] adjacencyList = new List[n];
for (int i = 0; i < n; i++) {
adjacencyList[i] = new ArrayList<>();
}
// Build the graph: Connect stones that share the same row or column
for (int i = 0; i < n; i++) {
for (int j = i + 1; j < n; j++) {
if (
stones[i][0] == stones[j][0] || stones[i][1] == stones[j][1]
) {
adjacencyList[i].add(j);
adjacencyList[j].add(i);
}
}
}
int numOfConnectedComponents = 0;
boolean[] visited = new boolean[n];
// Traverse all stones using DFS to count connected components
for (int i = 0; i < n; i++) {
if (!visited[i]) {
depthFirstSearch(adjacencyList, visited, i);
numOfConnectedComponents++;
}
}
// Maximum stones that can be removed is total stones minus number of connected components
return n - numOfConnectedComponents;
}
// DFS to visit all stones in a connected component
private void depthFirstSearch(
List<Integer>[] adjacencyList,
boolean[] visited,
int stone
) {
visited[stone] = true;
for (int neighbor : adjacencyList[stone]) {
if (!visited[neighbor]) {
depthFirstSearch(adjacencyList, visited, neighbor);
}
}
}
// V1-2
// IDEA : Disjoint Set Union
// https://leetcode.com/problems/most-stones-removed-with-same-row-or-column/editorial/
public int removeStones_1_2(int[][] stones) {
int n = stones.length;
UnionFind uf = new UnionFind(n);
// Populate uf by connecting stones that share the same row or column
for (int i = 0; i < n; i++) {
for (int j = i + 1; j < n; j++) {
if (
stones[i][0] == stones[j][0] || stones[i][1] == stones[j][1]
) {
uf.union(i, j);
}
}
}
return n - uf.count;
}
// Union-Find data structure for tracking connected components
private class UnionFind {
int[] parent; // Array to track the parent of each node
int count; // Number of connected components
UnionFind(int n) {
parent = new int[n];
Arrays.fill(parent, -1); // Initialize all nodes as their own parent
count = n; // Initially, each stone is its own connected component
}
// Find the root of a node with path compression
int find(int node) {
if (parent[node] == -1) {
return node;
}
return parent[node] = find(parent[node]);
}
// Union two nodes, reducing the number of connected components
void union(int n1, int n2) {
int root1 = find(n1);
int root2 = find(n2);
if (root1 == root2) {
return; // If they are already in the same component, do nothing
}
// Merge the components and reduce the count of connected components
count--;
parent[root1] = root2;
}
}
// V1-3
// IDEA : Disjoint Set Union (Optimized)
// https://leetcode.com/problems/most-stones-removed-with-same-row-or-column/editorial/
public int removeStones_1_3(int[][] stones) {
int n = stones.length;
UnionFind_1_3 uf = new UnionFind_1_3(20002); // Initialize UnionFind with a large enough range to handle coordinates
// Union stones that share the same row or column
for (int i = 0; i < n; i++) {
uf.union(stones[i][0], stones[i][1] + 10001); // Offset y-coordinates to avoid conflict with x-coordinates
}
return n - uf.componentCount;
}
// Union-Find data structure for tracking connected components
class UnionFind_1_3 {
int[] parent; // Array to track the parent of each node
int componentCount; // Number of connected components
Set<Integer> uniqueNodes; // Set to track unique nodes
UnionFind_1_3(int n) {
parent = new int[n];
Arrays.fill(parent, -1); // Initialize all nodes as their own parent
componentCount = 0;
uniqueNodes = new HashSet<>();
}
// Find the root of a node with path compression
int find(int node) {
// If node is not marked, increase the component count
if (!uniqueNodes.contains(node)) {
componentCount++;
uniqueNodes.add(node);
}
if (parent[node] == -1) {
return node;
}
return parent[node] = find(parent[node]);
}
// Union two nodes, reducing the number of connected components
void union(int node1, int node2) {
int root1 = find(node1);
int root2 = find(node2);
if (root1 == root2) {
return; // If they are already in the same component, do nothing
}
// Merge the components and reduce the component count
parent[root1] = root2;
componentCount--;
}
}
// V2
}